package com.mortals.xhx.daemon.task;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.service.ITask;
import com.mortals.framework.service.ITaskExcuteService;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.feign.user.IUserFeign;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.stereotype.Service;

/**
 * 同步用户,唯一标识为用户名。
 */
@Slf4j
@Service("SyncUserTask")
@ConditionalOnExpression("'${platform.type:null}'=='cloud'")
public class SyncUserTaskImpl implements ITaskExcuteService {

    @Autowired
    private IUserFeign userFeign;
    @Autowired
    private UserService userService;

    @Override
    public void excuteTask(ITask task) throws AppException {
        log.info("同步用户任务");

        userService.refreshUser();

      /*  UserPdu userPdu = new UserPdu();
        userPdu.setPage(1);
        userPdu.setSize(-1);
        Rest<RespData<List<UserPdu>>> resp = userFeign.list(userPdu);
        if (resp.getCode() == YesNoEnum.YES.getValue()) {
            List<UserPdu> userPduList = resp.getData().getData();
            log.info("用户总数量：{}", userPduList.size());
            if (!ObjectUtils.isEmpty(userPduList)) {
                List<UserEntity> newUserList = userPduList.stream().map(newUser -> {
                    UserEntity userEntity = new UserEntity();
                    userEntity.initAttrValue();
                    BeanUtils.copyProperties(newUser, userEntity,  new String[]{"id","lastLoginTime", "lastLoginAddress"});
                    return userEntity;
                }).collect(Collectors.toList());

                List<UserEntity> oldUserList = userService.find(new UserQuery());
                log.info(" oldUserList size：{}", oldUserList.size());

                Map<String, UserEntity> oldUserMap = oldUserList.stream().collect(Collectors.toMap(x -> x.getLoginName(), y -> y, (o, n) -> n));
                Map<String, UserEntity> newUserMap = newUserList.stream().collect(Collectors.toMap(x -> x.getLoginName(), y -> y, (o, n) -> n));


                List<UserEntity> saveUserList = newUserList.stream().map(item -> {
                    if (!oldUserMap.containsKey(item.getLoginName())) {
                        item.setCreateUserId(1L);
                        item.setCreateUserName("系统管理员");
                        item.setCreateTime(new Date());
                        return item;
                    }
                    return null;
                }).filter(f -> f != null).collect(Collectors.toList());


                if (!ObjectUtils.isEmpty(saveUserList)) {
                    log.info("用户新增，size:{}", saveUserList.size());
                    saveUserList.stream().forEach(item->{
                        userService.getUserDao().insert(item);
                    });

                    //userService.save(saveUserList);
                }

            }
            //查找新增 与更新


            //同步更新用户，以loginname为唯一标识，密码默认与用户相同
*//*            resp.getData().getData().forEach(user -> {
                log.info("loginName:{}", user.getLoginName());
                UserEntity tempEntity = userService.selectOne(new UserQuery().loginName(user.getLoginName()));
                if (ObjectUtils.isEmpty(tempEntity)) {
                    UserEntity userEntity = new UserEntity();
                    BeanUtils.copyProperties(user, userEntity, new String[]{"id","lastLoginTime", "lastLoginAddress"});
                    log.info("新增:{}", JSON.toJSONString(userEntity));
                    userService.getUserDao().insert(userEntity);
                }else {
                    //更新基本信息
                    UserEntity userEntity = new UserEntity();
                    BeanUtils.copyProperties(user, userEntity, new String[]{"loginPwd","userType","status","lastLoginTime", "lastLoginAddress"});
                    log.info("更新:{}", JSON.toJSONString(userEntity));
                    userService.getUserDao().update(userEntity);
                }
            });*//*
        }*/
       // log.info("syncUserResp:{}", JSON.toJSONString(resp));

    }


    @Override
    public void stopTask(ITask task) throws AppException {

    }


}
